"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObservable = useObservable;
const react_1 = require("react");
const react_cool_hooks_1 = require("react-cool-hooks");
const internal_1 = require("../internal");
function useObservable(...args) {
    if ((0, internal_1._isObservableArgument)(args)) {
        return observableHook(...args);
    }
    if ((0, internal_1._isObservableFactoryArgument)(args)) {
        return observableFactoryHook(...args);
    }
    return undefined;
}
function observableHook(observable) {
    const internalStateRef = (0, internal_1._useObservableInternals)(observable, (newValue, callback) => {
        setValue(newValue);
        callback();
    });
    const [internalValue, setValue] = (0, react_1.useState)(internalStateRef.valueCache);
    if (internalStateRef.valuesBuffer.size > 0) {
        return internalStateRef.valuesBuffer.dissolve();
    }
    return internalStateRef.reactStateUsed ? internalValue : internalStateRef.valueCache;
}
function observableFactoryHook(observableFactory) {
    const observable = (0, react_cool_hooks_1.useOnce)(observableFactory);
    return observableHook(observable);
}
//# sourceMappingURL=useObservable.js.map