"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRxCallback = useRxCallback;
const rxjs_1 = require("rxjs");
const useSubject_1 = require("./useSubject");
const react_cool_hooks_1 = require("react-cool-hooks");
const value_guards_1 = require("value-guards");
function useRxCallback(pipe) {
    const subject = (0, useSubject_1.useSubject)(() => new rxjs_1.Subject());
    const callback = (0, react_cool_hooks_1.useFunction)((...args) => subject.next(args));
    const result$ = (0, react_cool_hooks_1.useOnce)(() => {
        const operators = (0, value_guards_1.isFunction)(pipe)
            ? [pipe(), (0, rxjs_1.share)({ connector: () => new rxjs_1.Subject() })]
            : [];
        return subject.asObservable().pipe(...operators);
    });
    return [result$, callback];
}
//# sourceMappingURL=useRxCallback.js.map