"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTransitionObservable = useTransitionObservable;
const internal_1 = require("../internal");
const react_cool_hooks_1 = require("react-cool-hooks");
const react_1 = require("react");
function useTransitionObservable(...args) {
    if ((0, internal_1._isObservableArgument)(args)) {
        return observableHook(...args);
    }
    if ((0, internal_1._isObservableFactoryArgument)(args)) {
        return observableFactoryHook(...args);
    }
    return [false, undefined];
}
function observableHook(observable) {
    const [pending, startTransition] = (0, react_1.useTransition)();
    const internalStateRef = (0, internal_1._useObservableInternals)(observable, (newValue, callback) => {
        startTransition(() => {
            setValue(newValue);
            callback();
        });
    });
    const [internalValue, setValue] = (0, react_1.useState)(internalStateRef.valueCache);
    if (internalStateRef.valuesBuffer.size > 0) {
        return [pending, internalStateRef.valuesBuffer.dissolve()];
    }
    return [
        pending,
        internalStateRef.reactStateUsed ? internalValue : internalStateRef.valueCache
    ];
}
function observableFactoryHook(observableFactory) {
    const observable = (0, react_cool_hooks_1.useOnce)(observableFactory);
    return observableHook(observable);
}
//# sourceMappingURL=useTransitionObservable.js.map