"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWillUnmount = useWillUnmount;
const react_cool_hooks_1 = require("react-cool-hooks");
const rxjs_1 = require("rxjs");
/**
 * @summary Provides an observable for lifecycle hook "componentWillUnmount"
 * Creates memoized observable that emits only once and completes before component will unmount.
 */
function useWillUnmount() {
    const subject = (0, react_cool_hooks_1.useOnce)(() => new rxjs_1.Subject());
    (0, react_cool_hooks_1.useUnmountEffect)(() => {
        subject.next();
        subject.complete();
    });
    return (0, react_cool_hooks_1.useOnce)(() => subject.asObservable());
}
//# sourceMappingURL=useWillUnmount.js.map