"use strict";
var _Queue_instances, _Queue_size, _Queue_head, _Queue_tail, _Queue_pushOne;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Queue = void 0;
const tslib_1 = require("tslib");
const QueueNode_1 = require("./QueueNode");
class Queue {
    constructor(initialValues) {
        _Queue_instances.add(this);
        _Queue_size.set(this, 0);
        _Queue_head.set(this, null);
        _Queue_tail.set(this, null);
        if (initialValues) {
            this.push(...initialValues);
        }
    }
    get size() {
        if (!tslib_1.__classPrivateFieldGet(this, _Queue_head, "f") || !tslib_1.__classPrivateFieldGet(this, _Queue_tail, "f")) {
            return 0;
        }
        return tslib_1.__classPrivateFieldGet(this, _Queue_size, "f");
    }
    push(...values) {
        for (const value of values) {
            tslib_1.__classPrivateFieldGet(this, _Queue_instances, "m", _Queue_pushOne).call(this, value);
        }
        return tslib_1.__classPrivateFieldGet(this, _Queue_size, "f");
    }
    shift() {
        const headNode = tslib_1.__classPrivateFieldGet(this, _Queue_head, "f");
        tslib_1.__classPrivateFieldSet(this, _Queue_head, headNode?.nextNode ?? null, "f");
        if (!tslib_1.__classPrivateFieldGet(this, _Queue_head, "f")) {
            tslib_1.__classPrivateFieldSet(this, _Queue_tail, null, "f");
        }
        tslib_1.__classPrivateFieldSet(this, _Queue_size, Math.max(0, tslib_1.__classPrivateFieldGet(this, _Queue_size, "f") - 1), "f");
        return headNode?.value;
    }
    dissolve() {
        let lastValue;
        while (this.size > 0) {
            lastValue = this.shift();
        }
        return lastValue;
    }
}
exports.Queue = Queue;
_Queue_size = new WeakMap(), _Queue_head = new WeakMap(), _Queue_tail = new WeakMap(), _Queue_instances = new WeakSet(), _Queue_pushOne = function _Queue_pushOne(value) {
    var _a;
    const node = new QueueNode_1.QueueNode(value);
    tslib_1.__classPrivateFieldSet(this, _Queue_size, (_a = tslib_1.__classPrivateFieldGet(this, _Queue_size, "f"), ++_a), "f");
    if (tslib_1.__classPrivateFieldGet(this, _Queue_tail, "f")) {
        tslib_1.__classPrivateFieldSet(this, _Queue_tail, tslib_1.__classPrivateFieldGet(this, _Queue_tail, "f").append(node), "f");
    }
    else {
        tslib_1.__classPrivateFieldSet(this, _Queue_head, tslib_1.__classPrivateFieldSet(this, _Queue_tail, node, "f"), "f");
    }
};
//# sourceMappingURL=Queue.js.map