"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._useObservableInternals = _useObservableInternals;
const rxjs_1 = require("rxjs");
const useDidMount_1 = require("../hooks/useDidMount");
const react_cool_hooks_1 = require("react-cool-hooks");
const Queue_1 = require("./Queue");
const useSubscription_1 = require("../hooks/useSubscription");
function _useObservableInternals(observable, setStateFn) {
    const didMount$ = (0, useDidMount_1.useDidMount)();
    const internalStateRef = (0, react_cool_hooks_1.useOnce)(() => ({
        didMount: false,
        valuesBuffer: new Queue_1.Queue(),
        valueCache: undefined,
        reactStateUsed: false,
    }));
    const updateState = (0, react_cool_hooks_1.useFunction)((newValue) => {
        if (internalStateRef.didMount) {
            setStateFn(newValue, () => {
                internalStateRef.valueCache = newValue;
                internalStateRef.reactStateUsed = true;
            });
        }
        else {
            internalStateRef.valuesBuffer.push(newValue);
            internalStateRef.valueCache = newValue;
        }
    });
    (0, useSubscription_1.useSubscription)(() => (didMount$.subscribe(() => {
        internalStateRef.didMount = true;
    })), { immediate: true });
    (0, useSubscription_1.useSubscription)(observable, (currentObservable) => (currentObservable
        .pipe((0, rxjs_1.distinctUntilChanged)(), (0, rxjs_1.mergeWith)(didMount$.pipe((0, rxjs_1.map)(() => internalStateRef.valuesBuffer), (0, rxjs_1.filter)((valuesBuffer) => valuesBuffer.size > 0), (0, rxjs_1.map)((valuesBuffer) => valuesBuffer.dissolve()))))
        .subscribe((newValue) => {
        updateState(newValue);
    })), { immediate: true });
    return internalStateRef;
}
//# sourceMappingURL=_useObservableInternals.js.map