import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment, useMemo } from 'react';
import { from } from 'rxjs';
import { isDefined } from 'value-guards';
import { useTransitionObservable } from '../hooks/useTransitionObservable';
export function Render$({ $: source, definedOnly, fallback, children }) {
    const observable = useMemo(() => from(source), [source]);
    const [pending, value] = useTransitionObservable(observable);
    if (definedOnly) {
        return (_jsx(Fragment, { children: isDefined(value) ? (children(value, pending) ?? fallback ?? null) : (fallback ?? null) }));
    }
    else {
        return (_jsx(Fragment, { children: children(value, pending) ?? fallback ?? null }));
    }
}
Render$.displayName = 'Render$';
//# sourceMappingURL=Render$.js.map