import { share, Subject } from "rxjs";
import { useSubject } from "./useSubject";
import { useFunction, useOnce } from "react-cool-hooks";
import { isFunction } from "value-guards";
export function useRxCallback(pipe) {
    const subject = useSubject(() => new Subject());
    const callback = useFunction((...args) => subject.next(args));
    const result$ = useOnce(() => {
        const operators = isFunction(pipe)
            ? [pipe(), share({ connector: () => new Subject() })]
            : [];
        return subject.asObservable().pipe(...operators);
    });
    return [result$, callback];
}
//# sourceMappingURL=useRxCallback.js.map