import { useEffect } from 'react';
import { useOnce } from 'react-cool-hooks';
import { BehaviorSubject } from 'rxjs';
import { useSubject } from './useSubject';
export function useRxEffect() {
    const subject = useSubject(() => new BehaviorSubject(0));
    const effect$ = useOnce(() => subject.asObservable());
    useEffect(() => {
        subject.next(subject.getValue() + 1);
    });
    return effect$;
}
//# sourceMappingURL=useRxEffect.js.map