import { useFunction, useOnce } from 'react-cool-hooks';
import { distinctUntilChanged, Observable, share, Subject, switchMap } from 'rxjs';
import { useValueChange } from './useValueChange';
const EMPTY_DEPS = [];
export function useRxFactory(factory, deps = EMPTY_DEPS) {
    const wrappedFactory = useFunction(factory);
    const deps$ = useValueChange(deps);
    return useOnce(() => deps$.pipe(distinctUntilChanged((previous, current) => (Object.is(current, previous) || current.every((el, i) => Object.is(el, previous[i])))), switchMap(() => new Observable(wrappedFactory)), share({ connector: () => new Subject() })));
}
//# sourceMappingURL=useRxFactory.js.map