var _Queue_instances, _Queue_size, _Queue_head, _Queue_tail, _Queue_pushOne;
import { __classPrivateFieldGet, __classPrivateFieldSet } from "tslib";
import { QueueNode } from './QueueNode';
export class Queue {
    constructor(initialValues) {
        _Queue_instances.add(this);
        _Queue_size.set(this, 0);
        _Queue_head.set(this, null);
        _Queue_tail.set(this, null);
        if (initialValues) {
            this.push(...initialValues);
        }
    }
    get size() {
        if (!__classPrivateFieldGet(this, _Queue_head, "f") || !__classPrivateFieldGet(this, _Queue_tail, "f")) {
            return 0;
        }
        return __classPrivateFieldGet(this, _Queue_size, "f");
    }
    push(...values) {
        for (const value of values) {
            __classPrivateFieldGet(this, _Queue_instances, "m", _Queue_pushOne).call(this, value);
        }
        return __classPrivateFieldGet(this, _Queue_size, "f");
    }
    shift() {
        const headNode = __classPrivateFieldGet(this, _Queue_head, "f");
        __classPrivateFieldSet(this, _Queue_head, headNode?.nextNode ?? null, "f");
        if (!__classPrivateFieldGet(this, _Queue_head, "f")) {
            __classPrivateFieldSet(this, _Queue_tail, null, "f");
        }
        __classPrivateFieldSet(this, _Queue_size, Math.max(0, __classPrivateFieldGet(this, _Queue_size, "f") - 1), "f");
        return headNode?.value;
    }
    dissolve() {
        let lastValue;
        while (this.size > 0) {
            lastValue = this.shift();
        }
        return lastValue;
    }
}
_Queue_size = new WeakMap(), _Queue_head = new WeakMap(), _Queue_tail = new WeakMap(), _Queue_instances = new WeakSet(), _Queue_pushOne = function _Queue_pushOne(value) {
    var _a;
    const node = new QueueNode(value);
    __classPrivateFieldSet(this, _Queue_size, (_a = __classPrivateFieldGet(this, _Queue_size, "f"), ++_a), "f");
    if (__classPrivateFieldGet(this, _Queue_tail, "f")) {
        __classPrivateFieldSet(this, _Queue_tail, __classPrivateFieldGet(this, _Queue_tail, "f").append(node), "f");
    }
    else {
        __classPrivateFieldSet(this, _Queue_head, __classPrivateFieldSet(this, _Queue_tail, node, "f"), "f");
    }
};
//# sourceMappingURL=Queue.js.map