import { ReactElement, ReactNode } from 'react';
import { ObservableInput } from 'rxjs';
export type RenderAsyncDefinedOnlyProps<T> = {
    definedOnly: true;
    $: ObservableInput<T>;
    fallback?: ReactNode;
    children: (value: NonNullable<T>, pending: boolean) => ReactNode;
};
export type RenderAsyncBasicProps<T> = {
    definedOnly?: false;
    $: ObservableInput<T>;
    fallback?: ReactNode;
    children: (value: T | undefined, pending: boolean) => ReactNode;
};
export type RenderAsyncProps<T> = RenderAsyncDefinedOnlyProps<T> | RenderAsyncBasicProps<T>;
export declare function Render$<T>(props: RenderAsyncBasicProps<T>): ReactElement | null;
export declare function Render$<T>(props: RenderAsyncDefinedOnlyProps<T>): ReactElement | null;
export declare namespace Render$ {
    var displayName: string;
}
