import { Observable } from 'rxjs';
/**
 * @summary Provides an observable for lifecycle hook "componentDidMount"
 * Creates memoized observable that emits only once after component did mount.
 * Replays for each new subscriber while component lifecycle, completes before component will unmount.
 */
export declare function useDidMount(): Observable<void>;
