import { Observable } from 'rxjs';
interface ComboRef<T> extends CallableFunction {
    (value: T): () => void;
    get current(): T;
    set current(value: T);
}
/**
 * @summary Provides memoized observable and memoized RefCallback.
 * Replays the latest ref value for new subscribers.
 * Completes when component will unmount.
 */
export declare function useRxRef<T>(initialValue?: T): [Observable<T>, ComboRef<T>];
export {};
