import { Observable, Subscription } from 'rxjs';
export type SubscriptionFactory = {
    (): Subscription;
};
export type MultiSubscriptionFactory<T extends Observable<any>> = {
    (source: T): Subscription;
};
export type UseSubscriptionConfig = {
    immediate: boolean;
};
/**
 * @summary Custom hook for subscribing to observables.
 * Unsubscribes automatically when component will unmount or received updated dependencies.
 * Optionally allows to subscribe immediately (before hook "componentDidMount").
 */
export declare function useSubscription<T extends Observable<any>>(source: T, callback: MultiSubscriptionFactory<T>, config?: UseSubscriptionConfig): void;
export declare function useSubscription(callback: SubscriptionFactory, config?: UseSubscriptionConfig): void;
